#!/bin/bash

###
### This bash script takes three arguments:
##	$1 is the absolute path to the program to monitor
##	$2 is the name of the program to monitor
##	$3 is the arguments you want to pass to the program

## First we check to see if we are running the right version.
## -- we do this by checking our local version number file
## ---- we will check first to see if it exists, if it does, then we 
if [ ! -f $1/$2-local_version.number ]; then
	/bin/date -r $1/$2 > $1/$2-local_version.number
fi

## next we get the current time.
CURRENTTIME=$(/bin/date) 

/bin/date -r $1/$2 > $1/$2-new_version.number

difference=$(/usr/bin/cmp -l $1/$2-new_version.number $1/$2-local_version.number)

if [ "$(/bin/pidof $2)" ]; then
	## do stuff you need to do if it is running
	## echo "$CURRENTTIME - $2 is running..." >> $1/log.txt

	## if we have a different version than we should, then we restart the program	
	if [ "$difference" != "" ]; then

		## write to the log file that we needed to kill the old version of the program
		echo "$CURRENTTIME - We have an old version of $2 we need to kill" >> $1/log.txt

		/usr/bin/killall $2

		/bin/sleep 3
		$1/$2 $3

		/bin/sleep 1
		## write to the log file that we started up the new version of the program
		echo "    Started up new version of $2" >> $1/log.txt

		## finally we set the local version to be the same as the new version
		/bin/cp $1/$2-new_version.number $1/$2-local_version.number
		
	fi
	
else
	## if it's not running, we start it up
	/bin/sleep 1
	$1/$2 $3

	## write to the log file that we needed to start up the program 
	echo "$CURRENTTIME - $2 wasnt running, I started it up." >> $1/log.txt
	
fi
